connect-explorer lint:
    stage: lint and prettier
    allow_failure: false
    script:
        - yarn workspace @trezor/connect-explorer lint
    dependencies:
        - install and build

connect-explorer type check:
    stage: typescript type check
    allow_failure: true
    script:
        - yarn workspace @trezor/connect-explorer type-check
    dependencies:
        - install and build

connect-explorer type coverage:
    stage: typescript type check
    allow_failure: false
    script:
        - yarn workspace @trezor/connect-explorer type-coverage
    dependencies:
        - install and build

connect-explorer build:
    stage: build
    script:
        - yarn workspace @trezor/connect-explorer build
    artifacts:
        expire_in: 2 days
        when: always
        paths:
            - packages/connect-explorer/build
    dependencies:
        - install and build

connect-explorer deploy dev:
    stage: deploy to dev servers
    variables:
        DEPLOY_DIRECTORY: ${DEPLOY_BASE_DIR}/connect-explorer/${CI_BUILD_REF_NAME}
        DEPLOY_URL: ${DEV_SERVER_URL}/connect-explorer/${CI_BUILD_REF_NAME}
    dependencies:
        - install and build
        - connect-explorer build
    environment:
        name: ${CI_BUILD_REF_NAME}
        url: $BASE_REVIEW_URL/${CI_BUILD_REF_NAME}
        on_stop: connect-explorer delete review
    before_script: []
    script:
        - cd ${PACKAGE_PATH_CONNECT_EXPLORER}
        - echo "Deploy to dev servers"
        - mkdir -p ${DEPLOY_BASE_DIR}/connect-explorer
        - mkdir -p ${DEPLOY_DIRECTORY} # create build folder
        - rsync --delete -va build/ "${DEPLOY_DIRECTORY}/"
        - curl "https://api.telegram.org/bot${TELEGRAM_DEPLOY_BOT_TOKEN_PART1}:${TELEGRAM_DEPLOY_BOT_TOKEN_PART2}-${TELEGRAM_DEPLOY_BOT_TOKEN_PART3}/sendMessage?chat_id=-1001354778014&text=${DEPLOY_URL}"
    tags:
        - deploy

connect-explorer delete review:
    stage: deploy to dev servers
    variables:
        GIT_STRATEGY: none
        DEPLOY_DIRECTORY: ${DEPLOY_BASE_DIR}/connect-explorer/${CI_BUILD_REF_NAME}
    when: manual
    environment:
        name: ${CI_BUILD_REF_NAME}
        action: stop
    script:
        - cd packages/connect-explorer
        - 'rm -r "${DEPLOY_DIRECTORY}"'
    tags:
        - deploy
    dependencies:
        - install and build

connect-explorer test integration:
    image: cypress/base:10
    stage: integration testing
    script:
        - npx cypress install
        - CYPRESS_baseUrl=${DEV_SERVER_URL}/connect-explorer/${CI_BUILD_REF_NAME} yarn workspace @trezor/connect-explorer test:integration
    artifacts:
        expire_in: 2 days
        when: always
        paths:
            - connect-explorer/test/snapshots
            - connect-explorer/test/screenshots
    dependencies:
        - install and build
